#include <bits/stdc++.h>

using namespace std;

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int t, n, k;
    cin >> t >> n >> k;
    vector<int> v(n);
    for(int i = 0; i < n; i++) cin >> v[i];
    int x = 0;
    for(int i = 0; i < n; i++){
        if(x<=v[i]){
            x++;
        }else{
            x--;
        }
    }
    if(x == k){
        cout << "DA\n";
        if(t==1){
            for(int i = 0; i < n; i++){
                cout << v[i] << " ";
            }
            cout << "\n";
        }
    }else{
        cout << "NE\n";
    }
    return 0;
}